Index: /trunk/LMDZ.GENERIC/README
===================================================================
--- /trunk/LMDZ.GENERIC/README	(revision 1215)
+++ /trunk/LMDZ.GENERIC/README	(revision 1216)
@@ -1001,2 +1001,25 @@
 == 05/12/2013 == JL
 - corrected sugascorrk to work in the two band gray aproximation with -b 1x1 and NGAUSS=2
+
+== 03/04/2014 == EM
+Major cleanup, in order to ease the use of LMDZ.GENERIC with (parallel) dynamics
+in LMDZ.COMMON: (NB: this will break LMDZ.UNIVERSAL, which should be thrashed
+in the near future)
+- Updated makegcm_* scripts (and makdim) and added the "-full" (to enforce
+  full recomputation of the model) option
+- In dyn3d: converted control.h to module control_mod.F90 and converted
+  iniadvtrac.F to module infotrac.F90
+- Added module mod_const_mpi.F90 in dyn3d (not used in serial mode)
+- Rearanged input/outputs routines everywhere to handle serial/MPI cases.
+  physdem.F => phyredem.F90 , phyetat0.F => phyetat0.F90 ; all read/write
+  routines for startfi files are gathered in module iostart.F90
+- added parallelism related routines init_phys_lmdz.F90, comgeomphy.F90,
+  dimphy.F90, iniphysiq.F90, mod_grid_phy_lmdz.F90, mod_phys_lmdz_mpi_data.F90,
+  mod_phys_lmdz_mpi_transfert.F90, mod_phys_lmdz_omp_data.F90,
+  mod_phys_lmdz_omp_transfert.F90, mod_phys_lmdz_para.F90,
+  mod_phys_lmdz_transfert_para.F90 in phymars
+  and mod_const_mpi.F90 in dyn3d (for compliance with parallelism)
+- added created generic routines 'planetwide_maxval' and 'planetwide_minval',
+  in module "planetwide_mod", that enable obtaining the max and min of a field
+  over the whole planet. This should be further imroved with computation of
+  means (possibly area weighed), etc.
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/calfis.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/calfis.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/calfis.F	(revision 1216)
@@ -6,5 +6,5 @@
 c    Auteur :  P. Le Van, F. Hourdin 
 c   .........
-
+      USE infotrac, ONLY: tname, nqtot
       IMPLICIT NONE
 c=======================================================================
@@ -71,7 +71,7 @@
 #include "comvert.h"
 #include "comgeom2.h"
-#include "control.h"
-
-#include "advtrac.h"
+!#include "control.h"
+
+!#include "advtrac.h"
 !! this is to get tnom (tracers name)
 
@@ -85,5 +85,5 @@
       REAL pteta(iip1,jjp1,llm)
       REAL pmasse(iip1,jjp1,llm)
-      REAL pq(iip1,jjp1,llm,nqmx)
+      REAL pq(iip1,jjp1,llm,nqtot)
       REAL pphis(iip1,jjp1)
       REAL pphi(iip1,jjp1,llm)
@@ -92,5 +92,5 @@
       REAL pducov(iip1,jjp1,llm)
       REAL pdteta(iip1,jjp1,llm)
-      REAL pdq(iip1,jjp1,llm,nqmx)
+      REAL pdq(iip1,jjp1,llm,nqtot)
 c
       REAL pw(iip1,jjp1,llm)
@@ -103,5 +103,5 @@
       REAL pdufi(iip1,jjp1,llm)
       REAL pdhfi(iip1,jjp1,llm)
-      REAL pdqfi(iip1,jjp1,llm,nqmx)
+      REAL pdqfi(iip1,jjp1,llm,nqtot)
       REAL pdpsfi(iip1,jjp1)
       logical tracer
@@ -116,10 +116,10 @@
 c
       REAL zufi(ngridmx,llm), zvfi(ngridmx,llm)
-      REAL ztfi(ngridmx,llm),zqfi(ngridmx,llm,nqmx)
+      REAL ztfi(ngridmx,llm),zqfi(ngridmx,llm,nqtot)
 c
       REAL zvervel(ngridmx,llm)
 c
       REAL zdufi(ngridmx,llm),zdvfi(ngridmx,llm)
-      REAL zdtfi(ngridmx,llm),zdqfi(ngridmx,llm,nqmx)
+      REAL zdtfi(ngridmx,llm),zdqfi(ngridmx,llm,nqtot)
       REAL zdpsrf(ngridmx)
 c
@@ -170,25 +170,25 @@
 
 c
-      IF (firstcal) THEN
-         latfi(1)=rlatu(1)
-         lonfi(1)=0.
-         DO j=2,jjm
-            DO i=1,iim
-               latfi((j-2)*iim+1+i)= rlatu(j)
-               lonfi((j-2)*iim+1+i)= rlonv(i)
-            ENDDO
-         ENDDO
-         latfi(ngridmx)= rlatu(jjp1)
-         lonfi(ngridmx)= 0.
-
-         ! build airefi(), mesh area on physics grid
-         CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,aire,airefi)
-         ! Poles are single points on physics grid
-         airefi(1)=airefi(1)*iim
-         airefi(ngridmx)=airefi(ngridmx)*iim
-
-         CALL inifis(ngridmx,llm,day_ini,daysec,dtphys,
-     .                latfi,lonfi,airefi,rad,g,r,cpp)
-      ENDIF
+!      IF (firstcal) THEN
+!         latfi(1)=rlatu(1)
+!         lonfi(1)=0.
+!         DO j=2,jjm
+!            DO i=1,iim
+!               latfi((j-2)*iim+1+i)= rlatu(j)
+!               lonfi((j-2)*iim+1+i)= rlonv(i)
+!            ENDDO
+!         ENDDO
+!         latfi(ngridmx)= rlatu(jjp1)
+!         lonfi(ngridmx)= 0.
+!
+!         ! build airefi(), mesh area on physics grid
+!         CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,aire,airefi)
+!         ! Poles are single points on physics grid
+!         airefi(1)=airefi(1)*iim
+!         airefi(ngridmx)=airefi(ngridmx)*iim
+!
+!         CALL inifis(ngridmx,llm,day_ini,daysec,dtphys,
+!     .                latfi,lonfi,airefi,rad,g,r,cpp)
+!      ENDIF
 
 c
@@ -278,5 +278,5 @@
 c   43.bis Taceurs (en kg/kg)
 c   --------------------------
-      DO iq=1,nqmx
+      DO iq=1,nqtot
          DO l=1,llm
             zqfi(1,l,iq) = pq(1,1,l,iq)
@@ -425,5 +425,5 @@
 
       CALL physiq (ngridmx,llm,nq,
-     .     tnom,
+     .     tname,
      ,     debut,lafin,
      ,     rday_ecri,heure,dtphys,
@@ -467,8 +467,8 @@
 
 
-c   62. humidite specifique
+c   62. traceurs
 c   ---------------------
 
-      DO iq=1,nqmx
+      DO iq=1,nqtot
          DO l=1,llm
             DO i=1,iip1
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/control_mod.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/control_mod.F90	(revision 1216)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/control_mod.F90	(revision 1216)
@@ -0,0 +1,16 @@
+
+module control_mod
+
+  implicit none
+
+  integer,save :: nday ! # of days to run
+  integer,save :: day_step ! # of dynamical time steps per day
+  integer,save :: iperiod  ! make a Matsuno step before avery iperiod-1 LF steps
+  integer,save :: iconser !
+  integer,save :: idissip ! apply dissipation every idissip dynamical step
+  integer,save :: iphysiq ! call physics every iphysiq dynamical steps
+  integer,save :: anneeref ! reference year # ! not used
+  real,save :: periodav
+  integer,save :: ecritphy ! output data in "diagfi.nc" every ecritphy dynamical steps 
+
+end module control_mod
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/defrun_new.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/defrun_new.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/defrun_new.F	(revision 1216)
@@ -38,9 +38,11 @@
       USE ioipsl_getincom
       use sponge_mod,only: callsponge,nsponge,mode_sponge,tetasponge
+      use control_mod,only: nday, day_step, iperiod, anneeref,
+     &                      iconser, idissip, iphysiq, ecritphy
       IMPLICIT NONE
 
 #include "dimensions.h"
 #include "paramet.h"
-#include "control.h"
+!#include "control.h"
 #include "logic.h"
 #include "serre.h"
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/dynetat0.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/dynetat0.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/dynetat0.F	(revision 1216)
@@ -1,4 +1,5 @@
       SUBROUTINE dynetat0(fichnom,nq,vcov,ucov,
      .                    teta,q,masse,ps,phis,time)
+      use infotrac, only: tname, nqtot
       IMPLICIT NONE
 
@@ -30,5 +31,5 @@
 #include "serre.h"
 #include "logic.h"
-#include"advtrac.h"
+!#include"advtrac.h"
 
 c   Arguments:
@@ -328,10 +329,10 @@
 !           WRITE(str3(2:3),'(i2.2)') iq
 !           ierr =  NF_INQ_VARID (nid, str3, nvarid)
-! NB: tracers are now read in using their name ('tnom' from advtrac.h)
-!           write(*,*) "  loading tracer:",trim(tnom(iq))
-           ierr=NF_INQ_VARID(nid,tnom(iq),nvarid)
+! NB: tracers are now read in using their name ('tname' from infotrac)
+!           write(*,*) "  loading tracer:",trim(tname(iq))
+           ierr=NF_INQ_VARID(nid,tname(iq),nvarid)
            IF (ierr .NE. NF_NOERR) THEN
 !              PRINT*, "dynetat0: Le champ <"//str3//"> est absent"
-              PRINT*, "dynetat0: Le champ <"//trim(tnom(iq))//
+              PRINT*, "dynetat0: Le champ <"//trim(tname(iq))//
      &                "> est absent"
               PRINT*, "          Il est donc initialise a zero"
@@ -346,5 +347,5 @@
              IF (ierr .NE. NF_NOERR) THEN
 !                 PRINT*, "dynetat0: Lecture echouee pour "//str3
-               PRINT*, "dynetat0: Lecture echouee pour "//trim(tnom(iq))
+               PRINT*,"dynetat0: Lecture echouee pour "//trim(tname(iq))
                CALL abort
              ENDIF
@@ -354,7 +355,7 @@
 c        case when new tracer are added in addition to old ones
              write(*,*)'tracers 1 to ', nqold,'were already present'
-             write(*,*)'tracers ', nqold+1,' to ', nqmx,'are new'
+             write(*,*)'tracers ', nqold+1,' to ', nqtot,'are new'
              write(*,*)' and initialized to zero'
-             q(:,:,:,nqold+1:nqmx)=0.0
+             q(:,:,:,nqold+1:nqtot)=0.0
 !             yes=' '
 !            do while ((yes.ne.'y').and.(yes.ne.'n'))
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/dynredem.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/dynredem.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/dynredem.F	(revision 1216)
@@ -1,3 +1,4 @@
       SUBROUTINE dynredem0(fichnom,idayref,anneeref,phis,nq)
+      use infotrac, only: tname
       IMPLICIT NONE
 c=======================================================================
@@ -16,5 +17,5 @@
 #include "netcdf.inc"
 #include "serre.h"
-#include "advtrac.h"
+!#include "advtrac.h"
 c   Arguments:
 c   ----------
@@ -902,9 +903,9 @@
 !               ierr = NF_PUT_ATT_TEXT (nid, nvarid, "title", 12,
 !     .                          "Traceurs "//str3)
-             txt="Traceur "//trim(tnom(iq))
-#ifdef NC_DOUBLE
-               ierr=NF_DEF_VAR(nid,tnom(iq),NF_DOUBLE,4,dims4,nvarid)
-#else
-               ierr=NF_DEF_VAR(nid,tnom(iq),NF_FLOAT,4,dims4,nvarid)
+             txt="Traceur "//trim(tname(iq))
+#ifdef NC_DOUBLE
+               ierr=NF_DEF_VAR(nid,tname(iq),NF_DOUBLE,4,dims4,nvarid)
+#else
+               ierr=NF_DEF_VAR(nid,tname(iq),NF_FLOAT,4,dims4,nvarid)
 #endif
                ierr=NF_PUT_ATT_TEXT(nid,nvarid,"title",
@@ -954,4 +955,5 @@
       SUBROUTINE dynredem1(fichnom,time,
      .                     vcov,ucov,teta,q,nq,masse,ps)
+      use infotrac, only: nqtot, tname
       IMPLICIT NONE
 c=================================================================
@@ -963,5 +965,5 @@
 #include "comvert.h"
 #include "comgeom.h"
-#include"advtrac.h"
+!#include"advtrac.h"
 
       INTEGER nq, l
@@ -969,5 +971,5 @@
       REAL teta(ip1jmp1,llm)                   
       REAL ps(ip1jmp1),masse(ip1jmp1,llm)                   
-      REAL q(iip1,jjp1,llm,nqmx)
+      REAL q(iip1,jjp1,llm,nqtot)
       REAL q3d(iip1,jjp1,llm) !temporary variable
       CHARACTER*(*) fichnom
@@ -1052,8 +1054,8 @@
 !            WRITE(str3(2:3),'(i2.2)') iq
 !            ierr = NF_INQ_VARID(nid, str3, nvarid)
-            ierr=NF_INQ_VARID(nid,tnom(iq),nvarid)
+            ierr=NF_INQ_VARID(nid,tname(iq),nvarid)
             IF (ierr .NE. NF_NOERR) THEN
 !               PRINT*, "Variable "//str3//" n est pas definie"
-              PRINT*, "Variable "//trim(tnom(iq))//" n est pas definie"
+              PRINT*,"Variable "//trim(tname(iq))//" n est pas definie"
               CALL abort
             ENDIF
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/gcm.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/gcm.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/gcm.F	(revision 1216)
@@ -1,5 +1,9 @@
       PROGRAM gcm
 
+      use infotrac, only: iniadvtrac, nqtot, iadv
       use sponge_mod,only: callsponge,mode_sponge,sponge
+      use control_mod, only: nday, day_step, iperiod, iphysiq,
+     &                       iconser, ecritphy, idissip
+      use comgeomphy, only: initcomgeomphy
       IMPLICIT NONE
 
@@ -42,10 +46,10 @@
 #include "logic.h"
 #include "temps.h"
-#include "control.h"
+!#include "control.h"
 #include "ener.h"
 #include "netcdf.inc"
 #include "serre.h"
 #include "tracstoke.h"
-#include"advtrac.h"
+!#include"advtrac.h"
 
       INTEGER*4  iday ! jour julien
@@ -56,5 +60,5 @@
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
       real, dimension(ip1jmp1,llm) :: teta   ! temperature potentielle 
-      REAL q(ip1jmp1,llm,nqmx)               ! champs advectes
+      REAL,allocatable :: q(:,:,:)           ! champs advectes
       REAL ps(ip1jmp1)                       ! pression  au sol
       REAL pext(ip1jmp1)                     ! pression  extensive
@@ -79,5 +83,6 @@
 c   tendances dynamiques
       REAL dv(ip1jm,llm),du(ip1jmp1,llm)
-      REAL dteta(ip1jmp1,llm),dq(ip1jmp1,llm,nqmx),dp(ip1jmp1)
+      REAL dteta(ip1jmp1,llm),dp(ip1jmp1)
+      REAL,ALLOCATABLE :: dq(:,:,:)
 
 c   tendances de la dissipation
@@ -87,5 +92,6 @@
 c   tendances physiques
       REAL dvfi(ip1jm,llm),dufi(ip1jmp1,llm)
-      REAL dhfi(ip1jmp1,llm),dqfi(ip1jmp1,llm,nqmx),dpfi(ip1jmp1)
+      REAL dhfi(ip1jmp1,llm),dpfi(ip1jmp1)
+      REAL,ALLOCATABLE :: dqfi(:,:,:)
 
 c   variables pour le fichier histoire
@@ -123,5 +129,5 @@
       LOGICAL tracer
 	  data tracer/.true./
-      INTEGER nq
+!      INTEGER nq
 
 C Calendrier
@@ -150,4 +156,14 @@
       REAL vnat(ip1jm,llm),unat(ip1jmp1,llm)
 
+c-----------------------------------------------------------------------
+c    variables pour l'initialisation de la physique :
+c    ------------------------------------------------
+      INTEGER ngridmx
+      PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )
+      REAL zcufi(ngridmx),zcvfi(ngridmx)
+      REAL latfi(ngridmx),lonfi(ngridmx)
+      REAL airefi(ngridmx)
+      SAVE latfi, lonfi, airefi
+      INTEGER i,j
 
 c-----------------------------------------------------------------------
@@ -159,12 +175,25 @@
 
 c-----------------------------------------------------------------------
-c  Initialize tracers using iniadvtrac (Ehouarn, oct 2008)
-      CALL iniadvtrac(nq,numvanle)
-
-
-      CALL dynetat0("start.nc",nqmx,vcov,ucov,
+      CALL defrun_new( 99, .TRUE. )
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! FH 2008/05/02
+! A nettoyer. On ne veut qu'une ou deux routines d'interface 
+! dynamique -> physique pour l'initialisation
+!#ifdef CPP_PHYS
+      CALL init_phys_lmdz(iim,jjp1,llm,1,(/(jjm-1)*iim+2/))
+      call initcomgeomphy
+!#endif
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+! Initialize tracers
+      CALL iniadvtrac(nqtot,numvanle)
+! Allocation de la tableau q : champs advectes   
+      allocate(q(ip1jmp1,llm,nqtot))
+      allocate(dq(ip1jmp1,llm,nqtot))
+      allocate(dqfi(ip1jmp1,llm,nqtot))
+
+      CALL dynetat0("start.nc",nqtot,vcov,ucov,
      .              teta,q,masse,ps,phis, time_0)
-
-      CALL defrun_new( 99, .TRUE. )
 
 c  on recalcule eventuellement le pas de temps
@@ -196,4 +225,45 @@
      *                tetagdiv, tetagrot , tetatemp              )
 c
+
+c-----------------------------------------------------------------------
+c   Initialisation de la physique :
+c   -------------------------------
+
+!      IF (call_iniphys.and.(iflag_phys==1.or.iflag_phys>=100)) THEN
+         latfi(1)=rlatu(1)
+         lonfi(1)=0.
+         zcufi(1) = cu(1)
+         zcvfi(1) = cv(1)
+         DO j=2,jjm
+            DO i=1,iim
+               latfi((j-2)*iim+1+i)= rlatu(j)
+               lonfi((j-2)*iim+1+i)= rlonv(i)
+               zcufi((j-2)*iim+1+i) = cu((j-1)*iip1+i)
+               zcvfi((j-2)*iim+1+i) = cv((j-1)*iip1+i)
+            ENDDO
+         ENDDO
+         latfi(ngridmx)= rlatu(jjp1)
+         lonfi(ngridmx)= 0.
+         zcufi(ngridmx) = cu(ip1jm+1)
+         zcvfi(ngridmx) = cv(ip1jm-iim)
+
+         ! build airefi(), mesh area on physics grid
+         CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,aire,airefi)
+         ! Poles are single points on physics grid
+         airefi(1)=airefi(1)*iim
+         airefi(ngridmx)=airefi(ngridmx)*iim
+
+! Initialisation de la physique: pose probleme quand on tourne 
+! SANS physique, car iniphysiq.F est dans le repertoire phy[]... 
+! Il faut une cle CPP_PHYS
+!#ifdef CPP_PHYS
+!         CALL iniphysiq(ngridmx,llm,daysec,day_ini,dtphys/nsplit_phys,
+         CALL iniphysiq(ngridmx,llm,daysec,day_ini,dtphys,
+     &                latfi,lonfi,airefi,zcufi,zcvfi,rad,g,r,cpp,
+     &                1)
+!     &                iflag_phys)
+!#endif
+!         call_iniphys=.false.
+!      ENDIF ! of IF (call_iniphys.and.(iflag_phys.eq.1))
 
       CALL pression ( ip1jmp1, ap, bp, ps, p       )
@@ -229,5 +299,5 @@
      . 'c''est a dire du jour',i7,3x,'au jour',i7//)
 
-      CALL dynredem0("restart.nc",day_end,anne_ini,phis,nqmx)
+      CALL dynredem0("restart.nc",day_end,anne_ini,phis,nqtot)
 
       ecripar = .TRUE.
@@ -237,5 +307,5 @@
 
 c   Quelques initialisations pour les traceurs
-      call initial0(ijp1llm*nqmx,dq)
+      call initial0(ijp1llm*nqtot,dq)
 c     istdyn=day_step/4     ! stockage toutes les 6h=1jour/4
 c     istphy=istdyn/iphysiq
@@ -328,10 +398,10 @@
        IF( forward. OR . leapf )  THEN
 
-        DO iq = 1, nqmx
+        DO iq = 1, nqtot
 c
          IF ( iadv(iq).EQ.1.OR.iadv(iq).EQ.2 )  THEN
             CALL traceur( iq,iadv,q,teta,pk,w, pbaru, pbarv, dq )
 
-         ELSE IF( iq.EQ. nqmx )   THEN
+         ELSE IF( iq.EQ. nqtot )   THEN
 c
             iapp_tracvl = 5
@@ -341,5 +411,5 @@
 c
 
-            CALL vanleer(numvanle,iapp_tracvl,nqmx,q,pbaru,pbarv,
+            CALL vanleer(numvanle,iapp_tracvl,nqtot,q,pbaru,pbarv,
      *                      p, masse, dq,  iadv(1), teta, pk     )
 
@@ -413,5 +483,5 @@
 
 
-        CALL calfis( nqmx, lafin ,rdayvrai,rday_ecri,time  ,
+        CALL calfis( nqtot, lafin ,rdayvrai,rday_ecri,time  ,
      $                 ucov,vcov,teta,q,masse,ps,p,pk,phis,phi ,
      $     du,dv,dteta,dq,w, dufi,dvfi,dhfi,dqfi,dpfi,tracer)
@@ -421,5 +491,5 @@
 c      ------------------------------
 !        if(1.eq.2)then
-          CALL addfi( nqmx, dtphys, leapf, forward   ,
+          CALL addfi( nqtot, dtphys, leapf, forward   ,
      $                  ucov, vcov, teta , q   ,ps , masse,
      $                 dufi, dvfi, dhfi , dqfi ,dpfi  )
@@ -556,5 +626,5 @@
 c                 iav=0
 c              ENDIF
-c              CALL writedynav(histaveid, nqmx, itau,vcov ,
+c              CALL writedynav(histaveid, nqtot, itau,vcov ,
 c    ,                          ucov,teta,pk,phi,q,masse,ps,phis)
 c           ENDIF
@@ -569,5 +639,5 @@
        CALL test_period ( ucov,vcov,teta,q,p,phis )
        CALL dynredem1("restart.nc",0.0,
-     .                     vcov,ucov,teta,q,nqmx,masse,ps)
+     .                     vcov,ucov,teta,q,nqtot,masse,ps)
 
               CLOSE(99)
@@ -636,5 +706,5 @@
                   iav=0
                ENDIF
-c              CALL writedynav(histaveid, nqmx, itau,vcov ,
+c              CALL writedynav(histaveid, nqtot, itau,vcov ,
 c    ,                          ucov,teta,pk,phi,q,masse,ps,phis)
 
@@ -644,5 +714,5 @@
                  IF(itau.EQ.itaufin)
      . CALL dynredem1("restart.nc",0.0,
-     .                     vcov,ucov,teta,q,nqmx,masse,ps)
+     .                     vcov,ucov,teta,q,nqtot,masse,ps)
 
                  forward = .TRUE.
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/infotrac.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/infotrac.F90	(revision 1216)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/infotrac.F90	(revision 1216)
@@ -0,0 +1,135 @@
+MODULE infotrac
+
+IMPLICIT NONE
+! nqtot : total number of tracers and higher order of moment, water vapor and liquid included
+  INTEGER, SAVE :: nqtot
+  INTEGER,allocatable :: iadv(:)   ! tracer advection scheme number
+  CHARACTER(len=20),allocatable ::  tname(:) ! tracer name
+
+CONTAINS
+
+      subroutine iniadvtrac(nq,numvanle)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! routine which initializes tracer names and advection schemes
+! reads these infos from file 'traceur.def' but uses default values
+! if that file is not found.
+! Ehouarn Millour. Oct. 2008  (made this LMDZ4-like) for future compatibility 
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      IMPLICIT NONE
+
+!#include "dimensions.h"
+!#include "advtrac.h"
+!#include "control.h"
+
+! routine arguments:
+      INTEGER,INTENT(out) :: nq ! number of tracers
+      INTEGER,INTENT(out) :: numvanle
+
+! local variables:
+      LOGICAL :: first
+      INTEGER :: iq
+      INTEGER :: ierr
+      CHARACTER(len=3) :: qname
+
+! Look for file traceur.def
+      OPEN(90,file='traceur.def',form='formatted',status='old', &
+              iostat=ierr)
+      IF (ierr.eq.0) THEN
+        write(*,*) "iniadvtrac: Reading file traceur.def"
+        ! read number of tracers:
+        read(90,*,iostat=ierr) nq
+        if (ierr.ne.0) then
+          write(*,*) "iniadvtrac: error reading number of tracers"
+          write(*,*) "   (first line of traceur.def) "
+          stop
+        endif
+        
+        ! allocate arrays:
+        allocate(iadv(nq))
+        allocate(tname(nq))
+        
+        ! initialize advection schemes to Van-Leer for all tracers
+        do iq=1,nq
+          iadv(iq)=3 ! Van-Leer
+        enddo
+        
+        do iq=1,nq
+        ! minimal version, just read in the tracer names, 1 per line
+          read(90,*,iostat=ierr) tname(iq)
+          if (ierr.ne.0) then
+            write(*,*) 'iniadvtrac: error reading tracer names...'
+            stop
+          endif
+        enddo !of do iq=1,nq
+        close(90) ! done reading tracer names, close file
+      ENDIF ! of IF (ierr.eq.0)
+
+!  ....  Choix  des shemas d'advection pour l'eau et les traceurs  ...
+!  ...................................................................
+!
+!     iadv = 1    shema  transport type "humidite specifique LMD"  
+!     iadv = 2    shema   amont
+!     iadv = 3    shema  Van-leer
+!     iadv = 4    schema  Van-leer + humidite specifique
+!                        Modif F.Codron
+! 
+!
+      DO  iq = 1, nq-1
+       IF( iadv(iq).EQ.1 ) PRINT *,' Choix du shema humidite specifique'&
+       ,' pour le traceur no ', iq
+       IF( iadv(iq).EQ.2 ) PRINT *,' Choix du shema  amont',' pour le'  &
+       ,' traceur no ', iq
+       IF( iadv(iq).EQ.3 ) PRINT *,' Choix du shema  Van-Leer ',' pour' &
+       ,'le traceur no ', iq
+
+       IF( iadv(iq).EQ.4 )  THEN
+         PRINT *,' Le shema  Van-Leer + humidite specifique ',          &
+       ' est  uniquement pour la vapeur d eau .'
+         PRINT *,' Corriger iadv( ',iq, ')  et repasser ! '
+         CALL ABORT
+       ENDIF
+
+       IF( iadv(iq).LE.0.OR.iadv(iq).GT.4 )   THEN
+        PRINT *,' Erreur dans le choix de iadv (nqtot).Corriger et '    &
+       ,' repasser car  iadv(iq) = ', iadv(iq)
+         CALL ABORT
+       ENDIF
+      ENDDO
+
+       IF( iadv(nq).EQ.1 ) PRINT *,' Choix du shema humidite '          &
+       ,'specifique pour la vapeur d''eau'
+       IF( iadv(nq).EQ.2 ) PRINT *,' Choix du shema  amont',' pour la'  &
+       ,' vapeur d''eau '
+       IF( iadv(nq).EQ.3 ) PRINT *,' Choix du shema  Van-Leer '         &
+       ,' pour la vapeur d''eau'
+       IF( iadv(nq).EQ.4 ) PRINT *,' Choix du shema  Van-Leer + '       &
+       ,' humidite specifique pour la vapeur d''eau'
+!
+       IF( (iadv(nq).LE.0).OR.(iadv(nq).GT.4) )   THEN
+        PRINT *,' Erreur dans le choix de iadv (nqtot).Corriger et '    &
+       ,' repasser car  iadv(nqtot) = ', iadv(nqtot)
+         CALL ABORT
+       ENDIF
+
+      first = .TRUE.
+      numvanle = nq + 1
+      DO  iq = 1, nq
+        IF(((iadv(iq).EQ.3).OR.(iadv(iq).EQ.4)).AND.first ) THEN
+          numvanle = iq
+          first    = .FALSE. 
+        ENDIF
+      ENDDO
+!
+      DO  iq = 1, nq
+
+      IF( (iadv(iq).NE.3.AND.iadv(iq).NE.4).AND.iq.GT.numvanle )  THEN
+          PRINT *,' Il y a discontinuite dans le choix du shema de ',   &
+          'Van-leer pour les traceurs . Corriger et repasser . '
+           CALL ABORT
+      ENDIF
+
+      ENDDO
+!
+      end subroutine iniadvtrac
+
+END MODULE infotrac
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/iniconst.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/iniconst.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/iniconst.F	(revision 1216)
@@ -1,4 +1,5 @@
       SUBROUTINE iniconst
 
+      use control_mod, only: iphysiq, idissip
       IMPLICIT NONE
 c
@@ -13,5 +14,5 @@
 #include "comconst.h"
 #include "temps.h"
-#include "control.h"
+!#include "control.h"
 #include "comvert.h"
 
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/inidissip.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/inidissip.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/inidissip.F	(revision 1216)
@@ -8,4 +8,5 @@
 c   -------------
 
+      use control_mod, only: idissip, iperiod
       IMPLICIT NONE
 #include "dimensions.h"
@@ -14,5 +15,5 @@
 #include "comconst.h"
 #include "comvert.h"
-#include "control.h"
+!#include "control.h"
 
       LOGICAL lstardis
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/logic.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/logic.h	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/logic.h	(revision 1216)
@@ -3,5 +3,6 @@
 
       COMMON/logic/ purmats,physic,forward,leapf,apphys,grireg,
-     *  statcl,conser,apdiss,apdelq,saison,ecripar,fxyhypb,ysinus,hybrid,autozlevs
+     *  statcl,conser,apdiss,apdelq,saison,ecripar,fxyhypb,ysinus,
+     &  hybrid,autozlevs
 
       LOGICAL purmats,physic,forward,leapf,apphys,grireg,statcl,conser,
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/mod_const_mpi.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/mod_const_mpi.F90	(revision 1216)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/mod_const_mpi.F90	(revision 1216)
@@ -0,0 +1,16 @@
+MODULE mod_const_mpi
+
+  INTEGER :: COMM_LMDZ
+  INTEGER :: MPI_REAL_LMDZ
+ 
+
+CONTAINS 
+
+  SUBROUTINE init_const_mpi
+  IMPLICIT NONE
+  
+    COMM_LMDZ=0
+    MPI_REAL_LMDZ=0
+  END SUBROUTINE init_const_mpi
+
+END MODULE mod_const_mpi
Index: /trunk/LMDZ.GENERIC/libf/dyn3d/test_period.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/dyn3d/test_period.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/dyn3d/test_period.F	(revision 1216)
@@ -1,3 +1,6 @@
       SUBROUTINE test_period ( ucov, vcov, teta, q, p, phis )
+      
+      USE infotrac, ONLY: nqtot
+      IMPLICIT NONE
 c
 c     Auteur : P. Le Van  
@@ -14,5 +17,5 @@
 c
       REAL ucov(ip1jmp1,llm), vcov(ip1jm,llm), teta(ip1jmp1,llm) ,
-     ,      q(ip1jmp1,llm,nqmx), p(ip1jmp1,llmp1), phis(ip1jmp1)
+     ,      q(ip1jmp1,llm,nqtot), p(ip1jmp1,llmp1), phis(ip1jmp1)
 c
 c   .....  Variables  locales  .....
@@ -51,5 +54,5 @@
       
 c
-      DO nq =1, nqmx
+      DO nq =1, nqtot
         DO l =1, llm
           DO ij = 1, ip1jmp1, iip1
Index: /trunk/LMDZ.GENERIC/libf/grid/dimension/makdim
===================================================================
--- /trunk/LMDZ.GENERIC/libf/grid/dimension/makdim	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/grid/dimension/makdim	(revision 1216)
@@ -1,11 +1,11 @@
 #!/bin/bash
 
-nqmx=$1
-shift
+#nqmx=$1
+#shift
 for i in $* ; do
    list=$list.$i
 done
-
-fichdim=dimensions${list}.t${nqmx}
+fichdim=dimensions${list}
+#fichdim=dimensions${list}.t${nqmx}
 
 echo $fichdim
@@ -18,5 +18,5 @@
    jm=$2
    lm=$3
-   n2=$1
+#   n2=$1
    ndm=1
 
@@ -51,15 +51,12 @@
 !   INCLUDE 'dimensions.h'
 !
-!   dimensions.h contient les dimensions du modele
-!   ndm est tel que iim=2**ndm
-!   nqmx est la dimension de la variable traceur q
+!   dimensions.h contains the model dimensions
+!   
 !-----------------------------------------------------------------------
 
-      INTEGER, parameter :: iim= $im
+      INTEGER, parameter :: iim=$im
       INTEGER, parameter :: jjm=$jm
       INTEGER, parameter :: llm=$lm
       INTEGER, parameter :: ndm=$ndm
-
-      integer, parameter :: nqmx=$nqmx
 
 !-----------------------------------------------------------------------
